<template>
  <el-dialog
    v-loading="loading"
    :title="title"
    :center="true"
    align="left"
    top="12vh"
    width="650px"
    :close-on-click-modal="false"
    :visible.sync="showModelThis"
    element-loading-text="拼命加载中"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)"
    @close="showModelThis = false"
  >
    <el-card style="margin: -20px 0 0 0">
      <el-row :gutter="10">
        <el-col :span="24">
          <el-form
            ref="ruleForm"
            :model="ruleForm"
            status-icon
            :rules="rulesThis"
            label-width="70px"
            class="demo-ruleForm"
          >
            <el-form-item label="上一级">
              <el-input disabled :value="pid_name ? pid_name : '暂无上一级'" />
            </el-form-item>

            <el-form-item label="名称" prop="cat_name">
              <el-input
                v-model="ruleForm.cat_name"
                :disabled="id == '007'"
                placeholder="名称"
                maxlength="100"
              />
            </el-form-item>
          </el-form>
        </el-col>
        <el-col :span="24" style="text-align: right">
          <el-button v-if="id !== '007'" type="primary" @click="submitForm"
            >保 存
          </el-button>
          <el-button @click="showModelThis = false">{{
            id == "007" ? "关 闭" : "取 消"
          }}</el-button>
        </el-col>
      </el-row>
    </el-card>
  </el-dialog>
</template>
<script>
import asyncRequest from "@/apis/service/serviceParam/sort";
import resToken from "@/mixins/resToken";
import { isChinese } from "@/utils/validate";
export default {
  name: "sort",
  props: ["showModel", "id", "sitem", "titleList"],
  mixins: [resToken],
  data() {
    const validate_fund_code = (rule, value, callback) => {
      if (value === "") {
        callback();
      } else if (isChinese(value)) {
        callback(new Error("财务核算码不能包含汉字！"));
      } else {
        callback();
      }
    };
    return {
      loading: false,
      title: "添加服务分类",
      pid_name: "",
      showModelThis: this.showModel,
      specOptions: [],
      ruleForm: {
        id: "",
        cat_name: "",
        specs_id: [],
        cat_desc: "",
      },
      rulesThis: this.rules,
      rules: {
        cat_name: [{ required: true, message: "服务分类名称不能为空", trigger: "blur" }],
        specs_id: [
          {
            type: "array",
            required: true,
            message: "请至少选择一个服务分类规格",
            trigger: "change",
          },
        ],
        fund_code: [{ required: false, validator: validate_fund_code, trigger: "blur" }],

        cat_desc: [{ required: false, message: "", trigger: "blur" }],
      },
    };
  },
  watch: {
    showModel: function (val) {
      this.showModelThis = val;
      if (val) {
        this.initForm();
      }
    },
    showModelThis(val) {
      if (!val) {
        this.$emit("cancel");
      }
    },
  },
  methods: {
    async initForm() {
      this.loading = true;
      this.pid_name = "";
      this.titleList.forEach((e, i) => {
        this.pid_name += i !== 0 ? `${e.titleName}/` : "";
      });
      await this.resetForm();
      if (this.id === "002") {
        this.title = "添加服务分类";
        this.rulesThis = this.rules;
      } else if (this.id === "005") {
        this.title = "修改服务分类";
        this.rulesThis = this.rules;
        await this.initData();
      } else {
        this.title = "服务分类详情";
        this.rulesThis = {};
        await this.initData();
      }


      this.loading = false;
    },

    async resetForm() {
      // 重置
      await this.$nextTick(() => {
        if (this.$refs.ruleForm) {
          this.$refs.ruleForm.resetFields();
          this.$refs.ruleForm.clearValidate();
          const { id, cat_name, cat_desc } = this.sitem;
          this.ruleForm = {
            pid: this.titleList[this.titleList.length - 1].id || "0",
            id: id || "",
            cat_name: cat_name || "",
            specs_id: [],
            cat_desc: cat_desc || "",
          };
        }
      });
    },
  
    async initData() {
      const {
        pid,
        id,
        cat_name
      } = this.sitem
      this.ruleForm = {
        pid: (pid ?? "0") || "0",
        id: id || "",
        cat_name: cat_name || "",
      };
    },
    async submitForm() {
      await this.$refs.ruleForm.validate(async (valid) => {
        if (valid) {
          if (!this.loading) {
            this.loading = true;
            let model = JSON.parse(JSON.stringify(this.ruleForm));
            let res = {};
            if (this.id === "002") {
              delete model["id"];
              res = await asyncRequest.add(model);
            } else {
              res = await asyncRequest.update(model);
            }
            this.loading = false;
            if (res && res.code === 1) {
              const title = this.id === "002" ? "添加成功!" : "修改成功!";
              this.$notify.success({
                title,
                message: "",
              });

              this.showModelThis = false;
              // 刷新
              this.$emit("refresh");
            } 
          }
        } else {
          console.log("error submit!!");
          return false;
        }
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.sort {
}
</style>
